# 口内照脱矿项目

口内照脱矿项目使用Mask R-CNN对牙齿脱矿区域进行识别，并使用segment-anything对整张图片进行自动分割。通过识别到的脱矿区域来计算segment-anything识别到的mask的IOU，从而确定脱矿区域所在的牙齿蒙版，最后计算面积比输出在图片上。

## 目录

- [Install](#install)
- [Usage](#usage)

## Install

项目安装分为两个部分：requirements.txt和segment-anything模块

```shell
# 1.requirements.txt
pip install -r requirements.txt
# 2.segment-anything模块 参考https://github.com/facebookresearch/segment-anything源码安装
git clone git@github.com:facebookresearch/segment-anything.git
cd segment-anything; pip install -e .
```

## Getting Started

预测模型

```shell
python predict.py --image <single_image_path>
```

参数解释：

1. --image：单个图片路径，必须传
2. --model：模型权重文件地址，*default*='./save_weights/model_best.pth'
3. --save_dir：输出图片位置，*default*='./result'
4. ----seg_model：segment_anything模型权重，*default*='./seg_model/sam_vit_h_4b8939.pth'

## 文件结构：

``

 ├── backbone: 特征提取网络

 ├── network_files: Mask R-CNN网络

 ├── train_utils: 训练验证相关模块（包括coco验证相关）

 ├── my_dataset_coco.py: 自定义dataset用于读取COCO2017数据集

 ├── my_dataset_voc.py: 自定义dataset用于读取Pascal VOC数据集

 ├── train.py: 单GPU/CPU训练脚本

 ├── train_multi_GPU.py: 针对使用多GPU的用户使用

 ├── predict.py: 简易的预测脚本，使用训练好的权重进行预测

 ├── validation.py: 利用训练好的权重验证/测试数据的COCO指标，并生成record_mAP.txt文件

 └── transforms.py: 数据预处理（随机水平翻转图像以及bboxes、将PIL图像转为Tensor）

``

## 数据集

项目是把原始数据集转换成COCO数据集格式进行训练

